#         Portable Batch System (PBS) Software License
# 
# Copyright (c) 1999, MRJ Technology Solutions.
# All rights reserved.
# 
# Acknowledgment: The Portable Batch System Software was originally developed
# as a joint project between the Numerical Aerospace Simulation (NAS) Systems
# Division of NASA Ames Research Center and the National Energy Research
# Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
# 
# Redistribution of the Portable Batch System Software and use in source
# and binary forms, with or without modification, are permitted provided
# that the following conditions are met:
# 
# - Redistributions of source code must retain the above copyright and
#   acknowledgment notices, this list of conditions and the following
#   disclaimer.
# 
# - Redistributions in binary form must reproduce the above copyright and 
#   acknowledgment notices, this list of conditions and the following
#   disclaimer in the documentation and/or other materials provided with the
#   distribution.
# 
# - All advertising materials mentioning features or use of this software must
#   display the following acknowledgment:
# 
#   This product includes software developed by NASA Ames Research Center,
#   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
# 
#         DISCLAIMER OF WARRANTY
# 
# THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
# WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
# 
# IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
# THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
# NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# This license will be governed by the laws of the Commonwealth of Virginia,
# without reference to its choice of law rules.
################################################################################
# qterm: defines the layout and functions of the terminate server dialog box.
proc qterm {} {
  global hostsSelected qtermv cmdpath SERVER_HOSTS activeWindow default \
	 LABELFONT

  busy_cursor
## Bring up the standard Dialog box ##
  set qtermv(DialogBox) ".terminate"

  set dbox [popupDialogBox $qtermv(DialogBox) "Terminate Server Dialog"]
  set activeWindow($qtermv(DialogBox)) 1
  set dbox_top    [lindex $dbox 0]
  set dbox_bottom [lindex $dbox 1]

## TOP PART ##
  frame $dbox_top.header -height 10m -width 10m
  frame $dbox_top.footer -height 10m -width 10m
  frame $dbox_top.e
  frame $dbox_top.e.e1
  frame $dbox_top.r

  label $dbox_top.e.l -font $LABELFONT -text "Terminate server(s):"

  set jobidbox [buildFullListbox $dbox_top.e.e1 30x3 "" xyscroll 0]

  set jobidFrame [lindex $jobidbox 0]
  set qtermv(jobidField) [lindex $jobidbox 3]
  bind_text_readonly $qtermv(jobidField)

  foreach el $hostsSelected {
    $qtermv(jobidField) insert end $el
  }

  set radiobox [buildRadioboxes $dbox_top.r       \
                   {{{immed "immediate"}   \
		     {delay "delay"}   \
	           }} column 0 "type of shutdown" 1 1 1]
  set radioboxFrame  [lindex $radiobox 0]
  set radioboxImmed  [lindex $radiobox 1]
  set radioboxDelay  [lindex $radiobox 2]

  $radioboxImmed   configure -variable qtermv(type) -value immediate
  $radioboxDelay configure -variable qtermv(type) -value delay

  set qtermv(type)  $default(qterm_type)

## ARRANGE ON SCREEN

  pack forget $radioboxFrame $jobidFrame
  pack $dbox_top.e.l $dbox_top.e.e1 -side left -anchor nw
  pack $dbox_top.header $dbox_top.e $radioboxFrame $dbox_top.footer \
	-side top -anchor nw -padx 14m -pady 3


## BOTTOM PART ##
  set cmdButtons \
  [buildCmdButtons $dbox_bottom {{{term terminate} {cancel cancel} {help help}}} x 10m 10 3]

  set cmdTerminate [lindex $cmdButtons 1]
  set cmdCancel    [lindex $cmdButtons 2]
  set cmdHelp      [lindex $cmdButtons 3]
 
  $cmdTerminate configure -command {

    set exitcode [win_cmdExec $qtermv(DialogBox) \
		   	      "$cmdpath(QTERM) -t $qtermv(type) $hostsSelected"]

    if {$exitcode == 0} {
###   Assuming we now have no selected server since their respective servers
###   have been killed.
      set hostsSelected	""
      set queuesSelected ""
      after 500 [list getdata $SERVER_HOSTS]
      destroy $qtermv(DialogBox)
    }
  }
  $cmdCancel configure -command [list destroy $qtermv(DialogBox)]
  register_default_action $qtermv(DialogBox) $cmdCancel

  $cmdHelp configure -command {xpbs_help terminate $qtermv(DialogBox)}
  tkwait visibility $qtermv(DialogBox)
  remove_busy_cursor
  catch {tkwait window $qtermv(DialogBox)}
  set activeWindow($qtermv(DialogBox)) 0
  catch {unset qtermv}
}
